/*  1*/ #include <stdlib.h> 
/*  2*/ #include <stdio.h>
/*  3*/
/*  4*/ struct __single_llist { 
/*  5*/      struct __single_llist *next; /* a pointer on next element or NULL is end of list */
/*  6*/
/*  7*/      void*       data;            /* some data */
/*  8*/      size_t      size;            /* the data size but it will equal 0 
/*  9*/                                   /* when data contain a pointer address */   
/* 10*/ };    
/* 11*/
/* 12*/ typedef struct __single_llist  single_ll_t;
/* 13*/   
/* 14*/ #define SINGLE_LLIST_LENGTH     sizeof(single_ll_t)
/* 15*/
/* 16*/ #define SINGLE_LLIST_ITEM_NEW(buf,size) ({                              \
/* 17*/   single_ll_t  *__x = (single_ll_t  *)calloc(1,SINGLE_LLIST_LENGTH);    \
/* 18*/   size_t (__size) = (size); char* __src = (char *)(buf);                \
/* 19*/   do{                                                                   \
/* 20*/      if( (__x) ) {                                                      \
/* 21*/        if( (__size) > 0 && ((__x)->data=calloc( 1, ((__x)->size=(__size)))) )  \
/* 22*/         {                                                                      \
/* 23*/           char* __dst = (char*)((__x)->data);                           \
/* 24*/           while ( (__src) && ((__src) - (char *)(buf)) < (__x)->size )  \
/* 25*/               *(__dst)++ = *(__src)++;                                  \
/* 26*/         }else{                                                          \
/* 27*/             (__x)->data=(void *)buf;                                    \
/* 28*/         }                                                               \
/* 29*/        /* (__x)->next = NULL; */                                        \
/* 30*/      }                                                                  \
/* 31*/   }while(0);                                                            \
/* 32*/   __x; })
/* 33*/
/* 34*/ static __inline__ single_ll_t* single_llist_item_new ( void *buf_p, size_t size )
/* 35*/ {
/* 36*/   return SINGLE_LLIST_ITEM_NEW(buf_p,size); 
/* 37*/ } 
/* 38*/
/* 39*/ #define SINGLE_LLIST_ITEM_FREE(x) ({                                    \
/* 40*/    single_ll_t  *__x = (x);                                             \
/* 41*/    if ( (__x) ) {                                                       \
/* 42*/       if ( (__x)->size > 0 && (__x)->data ) { free((__x)->data); (__x)->data == NULL; }    \
/* 43*/       free((__x)); (__x) = NULL;                                        \
/* 44*/    }                                                                    \
/* 45*/    __x;})                      
/* 46*/ 
/* 47*/ static __inline__ void single_llist_item_free ( single_ll_t **x_pp )
/* 48*/ {  
/* 49*/    if ( x_pp )
/* 50*/       *x_pp = SINGLE_LLIST_ITEM_FREE(*x_pp);
/* 51*/ }
/* 52*/
/* 53*/ #define SINGLE_LLIST_ITEM_APPEND(L,x) ({                                \
/* 54*/    single_ll_t  *__head = (L), *__x = (x), *__prev=NULL;                \
/* 55*/    if ( x )                                                             \
/* 56*/      do{                                                                \
/* 57*/        for ( ; (__head) ; (__head)= (__prev)->next )                    \
/* 58*/                 (__prev) = (__head);                                    \
/* 59*/        if ( (__x) ) {                                                   \
/* 60*/           (__head) = (__x);                                             \
/* 61*/           if ( (__prev) ) (__prev)->next = (__head);                    \
/* 62*/        }                                                                \
/* 63*/    }while(0); __head; })                                                
/* 64*/    
/* 65*/ static __inline__ single_ll_t  *single_llist_item_append ( single_ll_t *list_p, single_ll_t *x_p )      
/* 66*/ {
/* 67*/    single_ll_t  *head_p = SINGLE_LLIST_ITEM_APPEND(list_p,x_p);
/* 68*/    return ( !list_p ? head_p : list_p );   
/* 69*/ }
/* 70*/
/* 71*/ static __inline__ single_ll_t  *single_llist_item_pop(single_ll_t ** list_pp) {  
/* 72*/     single_ll_t  *item_p = ( list_pp ? *list_pp : NULL );
/* 73*/     if( item_p ) {
/* 74*/       *list_pp = item_p->next;         
/* 75*/     }  
/* 76*/     return item_p;
/* 77*/ }  
/* 78*/
/* 79*/ #define SINGLE_LLIST_ITEM_PUSH(L,x) ({                                  \
/* 80*/     single_ll_t  *__head = (L), *__x = (x);                             \
/* 81*/     if ( (__x) ) {                                                      \
/* 82*/        (__x)->next = (__head);                                          \
/* 83*/        (__head) = (__x);                                                \
/* 84*/     }                                                                   \
/* 85*/     __head; })
/* 86*/
/* 87*/ #define SINGLE_LLIST_DEPTH(L) ({                                        \
/* 88*/     single_ll_t  *__head = (L); size_t __n = 0;                         \
/* 89*/   do{                                                                   \
/* 90*/     while ( (__head) != NULL ) { (__head) = (__head)->next; (__n)++; }  \
/* 91*/   }while(0); __n; })
/* 92*/
/* 93*/ #define SINGLE_LLIST_ITEM_GET(L,idx) ({                                 \
/* 94*/    single_ll_t  *__head = (L);                                          \
/* 95*/    unsigned long __idx = (idx), __n = 0;                                \
/* 96*/    do{                                                                  \
/* 97*/        for ( ; (__head) ; (__head)=(__head)->next )                     \
/* 98*/            if ( (__idx) == (__n)++ ) break;                             \
/* 99*/    }while(0); __head; })                                                
/*100*/
/*101*/  typedef unsigned long  __usize_t;
/*102*
/*103*/  struct  __sll_hash_table {  
/*104*/     single_ll_t**   table_p;
/*105*/     __usize_t      length;
/*106*/  };
/*107*/ 
/*108*/  typedef struct  __sll_hash_table  sll_hash_tbl_t;
/*109*/ 
/*110*/  #define  hash_table      hash_tbl_p->table_p            
/*111*/  #define  hash_length     hash_tbl_p->length
/*112*/ 
/*113*/  static __inline__ void  sll_hash_tbl_reset( sll_hash_tbl_t *hash_tbl_p, int is_init )
/*114*/  {
/*115*/    if ( hash_tbl_p ) {
/*116*/      if( !is_init && hash_table && hash_length > 0 ) free(hash_table);      
/*117*/       hash_table  = NULL;
/*118*/       hash_length = 0UL;
/*119*/    }
/*120*/  }
/*121*/  
/*122*/  static __inline__ int sll_hash_tbl_insert ( sll_hash_tbl_t *hash_tbl_p, single_ll_t  *head )
/*123*/  {
/*124*/    if ( hash_tbl_p && head ) {    
/*125*/       hash_table = (single_ll_t **)( hash_table != NULL ?  
/*130*/                                      realloc ( hash_table, (hash_length+1) * sizeof(single_ll_t*) ) :
/*131*/                                      malloc ( sizeof(single_ll_t*) ) );
/*128*/       if ( hash_table ) {
/*129*/         *(hash_table+hash_length) = head;
/*130*/          hash_length++;  
/*131*/         return 0;
/*132*/       } 
/*133*/    }
/*134*/    return -1;
/*135*/  }     
/*136*/
/*137*/  static __inline__ single_ll_t* sll_hash_tbl_get ( sll_hash_tbl_t *hash_tbl_p, unsigned long idx )
/*138*/  {
/*139*/     return ( hash_tbl_p == NULL ? NULL :
/*140*/                                   (idx < hash_length ? *(hash_table+idx) : NULL) );
/*141*/  } 
/*142*/  /* Executed part of Singly Linked List Algorithm */
/*143*/
/*144*/ #include <limits.h>
/*145*/ const unsigned char  ubyte_value   = UCHAR_MAX-1;
/*146*/ const unsigned short uword_value   = USHRT_MAX-1;
/*147*/ const unsigned int   udword_value  = UINT_MAX-1;
/*148*/ const unsigned long  uqword_value  = ULONG_MAX-1; 
/*149*/ #include <float.h>    
/*150*/ const float          fp_value       = (FLT_MAX-1.0);
/*151*/ const double         efp_value      = (DBL_MAX-1.0);
/*152*/ const char           text_value[64] = {'h','e','l','l','o',' ','w','o','r','l','d','!','\0'}; 
/*153*/
/*154*/ #define VARIABLE_APPEND_MACROS(NAME)                                    \
/*155*/     item_p = single_llist_item_new((void *) & NAME ## _value,sizeof(NAME ## _value)); \
/*156*/     if( item_p ) {                                                      \
/*157*/       list_p = single_llist_item_append ( list_p, item_p );             \
/*158*/     }                                                                   \
/*159*/     printf ("(%08X)--(%08X)--(%08X)[%02X][%02X]: %s(data: %08X, size: %02X)\n", list_p, prev_p, item_p, \
/*160*/                                                                     (unsigned long)item_p-(unsigned long)prev_p,  \
/*161*/                                                                     SINGLE_LLIST_LENGTH,                \
/*162*/                                                                     list_p ? "append" : "failure",      \
/*163*/                                                                     list_p ? item_p->data : NULL,       \
/*164*/                                                                     list_p ? item_p->size : 0 );        \
/*165*/     prev_p = item_p         
/*166*/      
/*167*/ #define VARIABLE_PUSH_MACROS(NAME)                                                    \
/*168*/     item_p = single_llist_item_new((void *) & NAME ## _value,sizeof(NAME ## _value)); \
/*169*/     if( item_p ) {                                                                    \
/*170*/       list_p = SINGLE_LLIST_ITEM_PUSH ( list_p, item_p );                             \
/*171*/     }                                                                                 \
/*172*/     printf ("(%08X)--(%08X)--(%08X): %s(data: %08X, size: %02X)\n", list_p, prev_p, item_p,         \
/*173*/                                                                     list_p ? "append" : "failure",  \
/*174*/                                                                     list_p ? item_p->data : NULL,   \
/*175*/                                                                     list_p ? item_p->size : 0 );    \
/*176*/     prev_p = item_p        
/*177*/ 
/*178*/ #define POINTER_APPEND_MACROS(p)                                    \
/*179*/     item_p = single_llist_item_new((void *)p,0); \
/*180*/     if( item_p ) {                                                      \
/*181*/       list_p = single_llist_item_append ( list_p, item_p );             \
/*182*/     }                                                                   \
/*183*/     printf ("(%08X)--(%08X)--(%08X)[%02X][%02X]: %s(pointer: %08X)\n", list_p, prev_p, item_p, \
/*184*/                                                                     (unsigned long)item_p-(unsigned long)prev_p, \
/*185*/                                                                     SINGLE_LLIST_LENGTH, \
/*186*/                                                                     list_p ? "append" : "failure",  \
/*187*/                                                                     list_p ? item_p->data : NULL );  \
/*188*/     prev_p = item_p         
/*189*/
/*190*/ #define POINTER_PUSH_MACROS(p)                                                    \
/*191*/     item_p = single_llist_item_new((void *)p, 0); \
/*192*/     if( item_p ) {                                                                    \
/*193*/       list_p = SINGLE_LLIST_ITEM_PUSH ( list_p, item_p );                             \
/*194*/     }                                                                                 \
/*195*/     printf ("(%08X)--(%08X)--(%08X): %s(pointer: %08X)\n", list_p, prev_p, item_p,    \
/*196*/                                                            list_p ? "append" : "failure",  \
/*197*/                                                            list_p ? item_p->data : NULL ); \
/*198*/     prev_p = item_p        
/*199*/ 
/*200*/ typedef struct {
/*201*/       struct timeval  sa_runtime;
/*202*/       struct timeval  ht_runtime;
/*203*/       struct timeval pop_runtime;
/*204*/ } timer_stat_t;
/*205*/  
/*206*/ static int test_procedure_for_four_stage( unsigned long  nitems, timer_stat_t *stat_p );
/*207*/  
/*208*/ int main (void)
/*209*/ {
/*210*/   void             *__main_addr_p = (void *) & main/* __builtin_return_address(0)*/;
/*211*/   single_ll_t      *list_p = NULL, *item_p, *prev_p = NULL;
/*212*/   unsigned char    ubyte;
/*213*/   unsigned short   uword;
/*214*/   unsigned int     udword;
/*215*/   unsigned long    uqword, nitems;
/*216*/   float            fp;
/*217*/   char             text[32];
/*218*/   single_ll_t      list;
/*219*/   timer_stat_t     tm_stat;
/*220*/       
/*221*/   printf ("sizeof \'single_ll_t\': %lu, size \'next\': %lu, sizeof \'data\': %lu, sizeof \'size\': %lu\n",
/*222*/                    sizeof(list),
/*223*/                    sizeof(list.next),
/*224*/                    sizeof(list.data),
/*225*/                    sizeof(list.size) );                                    
/*226*/    
/*227*/   printf ("--- 1st stage. APPEND procedure ---\n");
/*228*/   VARIABLE_APPEND_MACROS(ubyte);
/*229*/   VARIABLE_APPEND_MACROS(uword);
/*230*/   VARIABLE_APPEND_MACROS(udword);
/*231*/   VARIABLE_APPEND_MACROS(uqword);
/*232*/   VARIABLE_APPEND_MACROS(fp);
/*233*/   VARIABLE_APPEND_MACROS(text);
/*234*/   POINTER_APPEND_MACROS(__main_addr_p);
/*235*/   POINTER_APPEND_MACROS(__main_addr_p);
/*236*/   POINTER_APPEND_MACROS(__main_addr_p);
/*237*/
/*238*/   printf ("DEPTH: %d items\n", SINGLE_LLIST_DEPTH(list_p) );
/*239*/   printf ("--- 2nd stage. POP procedure (after append) ---\n");
/*240*/   prev_p = NULL;
/*241*/   while ( (item_p=single_llist_item_pop(&list_p)) != NULL ) {
/*242*/      printf ("(%08X)--(%08X)--(%08X): %s (data: %08X, size: %02X)\n", list_p, prev_p, item_p,
/*243*/                                                                       item_p ? "pop" : "failure",  
/*244*/                                                                       item_p ? item_p->data : NULL,
/*245*/                                                                       item_p ? item_p->size : 0 );
/*246*/      prev_p = list_p; 
/*247*/      single_llist_item_free ( &item_p );
/*248*/   }
/*249*/      
/*250*/   printf ("--- 3rd stage. PUSH procedure ---\n");
/*251*/   VARIABLE_PUSH_MACROS(ubyte);
/*252*/   VARIABLE_PUSH_MACROS(uword);
/*253*/   VARIABLE_PUSH_MACROS(udword);
/*254*/   VARIABLE_PUSH_MACROS(uqword);
/*255*/   VARIABLE_PUSH_MACROS(fp);
/*256*/   VARIABLE_PUSH_MACROS(text);
/*257*/   POINTER_PUSH_MACROS(__main_addr_p);
/*258*/   printf ("DEPTH: %d items\n", SINGLE_LLIST_DEPTH(list_p) );
/*259*/   printf ("--- 4th stage. POP procedure (after push) ---\n");
/*260*/    
/*261*/   while ( (item_p=single_llist_item_pop(&list_p)) != NULL ) {
/*262*/      printf ("(%08X)--(%08X)--(%08X): %s (data: %08X, size: %02X)\n", list_p, prev_p, item_p,
/*263*/                                                                       item_p ? "pop" : "failure",  
/*264*/                                                                       item_p ? item_p->data : NULL,
/*265*/                                                                       item_p ? item_p->size : 0 );
/*266*/      prev_p = list_p; 
/*267*/      single_llist_item_free ( &item_p );
/*268*/   }
/*269*/   printf ("--- 5th stage. Comparing use of Hash table and Serial Access to list item ---\n");
/*270*/     printf ("#nitems\tSerial access\tHash table\tPOP method\n");   
/*271*/     for ( nitems=1UL; nitems < 100; nitems += 10 ) {
/*272*/         (void)test_procedure_for_four_stage( nitems, &tm_stat );
/*273*/         printf ("%6d \t %2lu.%06lu \t %2lu.%06lu \t%2lu.%06lu\n", nitems, 
/*274*/                                        tm_stat.sa_runtime.tv_sec,tm_stat.sa_runtime.tv_usec,
/*275*/                                        tm_stat.ht_runtime.tv_sec,tm_stat.ht_runtime.tv_usec, 
/*276*/                                        tm_stat.pop_runtime.tv_sec,tm_stat.pop_runtime.tv_usec );
/*277*/     }
/*278*/     for ( nitems=100UL; nitems < 2100; nitems += 100 ) {
/*279*/         (void)test_procedure_for_four_stage( nitems, &tm_stat );
/*280*/         printf ("%6d \t %2lu.%06lu \t %2lu.%06lu \t%2lu.%06lu\n", nitems, 
/*281*/                                        tm_stat.sa_runtime.tv_sec,tm_stat.sa_runtime.tv_usec,
/*282*/                                        tm_stat.ht_runtime.tv_sec,tm_stat.ht_runtime.tv_usec, 
/*283*/                                        tm_stat.pop_runtime.tv_sec,tm_stat.pop_runtime.tv_usec );
/*284*/     }
/*285*/   return 0;
/*286*/ }   
/*287*/
/*288*/ #include <sys/time.h>
/*289*/ #include <alloca.h>
/*290*/
/*291*/ static int test_procedure_for_four_stage( unsigned long  nitems,
/*292*/                                           timer_stat_t   *tm_stat_p )
/*293*/ {
/*294*/   unsigned long    item_i = 0UL;
/*295*/   const char       *p = text_value;
/*296*/   single_ll_t      *list_p = NULL, *item_p;
/*297*/   sll_hash_tbl_t   hash_tbl;     
/*298*/   struct timeval   start, end;
/*299*/   struct timeval   *ht_diff = alloca( nitems * sizeof(struct timeval)),
/*300*/                    *sa_diff = alloca( nitems * sizeof(struct timeval)),
/*301*/                    *pop_diff = alloca( nitems * sizeof(struct timeval));
/*302*/   
/*303*/   tm_stat_p->sa_runtime.tv_sec   = 0UL;
/*304*/   tm_stat_p->sa_runtime.tv_usec  = 0UL;
/*305*/   tm_stat_p->ht_runtime.tv_sec   = 0UL;
/*306*/   tm_stat_p->ht_runtime.tv_usec  = 0UL;
/*307*/   tm_stat_p->pop_runtime.tv_sec  = 0UL;
/*308*/   tm_stat_p->pop_runtime.tv_usec = 0UL;
/*309*/   sll_hash_tbl_reset ( &hash_tbl, 1 ); 
/*310*/   while  ( item_i++ < nitems ) {     
/*311*/         item_p = single_llist_item_new((void *)p,0); 
/*312*/         if( item_p ) {                            
/*313*/           list_p = SINGLE_LLIST_ITEM_PUSH ( list_p, item_p );
/*314*/           sll_hash_tbl_insert( &hash_tbl, item_p ); 
/*315*/         }
/*316*/   }      
/*317*/   /* Use of Serial Access to list item */
/*318*/   for ( item_i=0 ; item_i < nitems; item_i++ ) {
/*319*/      unsigned long idx = random() % nitems;
/*320*/      gettimeofday ( &start, NULL ); 
/*321*/      item_p = SINGLE_LLIST_ITEM_GET(list_p,idx);
/*322*/      if( item_p == NULL ) {
/*323*/        sll_hash_tbl_reset ( &hash_tbl, 0 );
/*324*/        printf ("Terminated! An error occured on try to access %d item.\n", idx);
/*325*/        return -1;
/*326*/      }
/*327*/      gettimeofday ( &end, NULL );
/*328*/      timersub( &end, &start, sa_diff+item_i );
/*329*/      timeradd( &(tm_stat_p->sa_runtime), sa_diff+item_i, &(tm_stat_p->sa_runtime) );               
/*330*/   }
/*331*/   /* Use of Hash table for access to list item */
/*332*/   for ( item_i=0 ; item_i < nitems; item_i++ ) {
/*333*/      unsigned long idx = random() % nitems;
/*334*/      gettimeofday ( &start, NULL ); 
/*335*/      item_p = sll_hash_tbl_get (&hash_tbl, idx ); 
/*336*/      if( item_p == NULL ) {
/*337*/        sll_hash_tbl_reset ( &hash_tbl, 0 );
/*338*/        printf ("Terminated! An error occured on try to access %d item.\n", idx);
/*339*/        return -1;
/*340*/      }
/*341*/      gettimeofday ( &end, NULL );
/*342*/      timersub( &end, &start, ht_diff+item_i );
/*343*/      timeradd( &(tm_stat_p->ht_runtime), ht_diff+item_i, &(tm_stat_p->ht_runtime) );               
/*344*/   }        
/*345*/
/*346*/   /* Use of POP method on access to list item */
/*347*/   gettimeofday ( &start, NULL ); 
/*348*/   while ( (item_p=single_llist_item_pop(&list_p)) != NULL ) {
/*349*/      gettimeofday ( &end, NULL );
/*350*/      timersub( &end, &start, pop_diff+item_i );
/*351*/      timeradd( &(tm_stat_p->pop_runtime), pop_diff+item_i, &(tm_stat_p->pop_runtime) );
/*352*/      single_llist_item_free ( &item_p );
/*353*/      gettimeofday ( &start, NULL ); 
/*354*/   }
/*355*/   sll_hash_tbl_reset ( &hash_tbl, 0 );
/*356*/   return 0;   
/*357*/ }
/*358*/
/*eof*/


