# VARIABLES: haven't used.
# description: the operation code contained a encode of data size (in lower bits) 
#              if this opcode have length in one byte. You may check it if you will 
#              follow the truth table and how instruction mov will use the listed 
#              registers in this table by call opcode  
# ---------------------------------------------------------------------------
# REG     REG NAME    Data size of    Mandatory     Opcode       Immediate   
# CODE                immediate        prefix                    Operand        
#                     operand, bits           
#---------------------------------------------------------------------------- 
#            AL          8              -             0xB8          0xff
# 000        AX         16             0x66           0xB8         0xffff
#            EAX        32              -             0xB8       0xffffffff
#----------------------------------------------------------------------------   
#            CL          8              -             0xB9          0xff               
# 001        CX         16             0x66           0xB9         0xffff
#            ECX        32              -             0xB9       0xffffffff
#----------------------------------------------------------------------------
#            DL          8              -             0xBA          0xff                 
# 010        DX         16             0x66           0xBA         0xffff
#            EDX        32              -             0xBA       0xffffffff          
#----------------------------------------------------------------------------
#            BL          8              -             0xBB          0xff 
# 011        BX         16             0x66           0xBB         0xffff 
#            EBX        32              -             0xBB       0xffffffff   
#----------------------------------------------------------------------------
# 101        EBP        32              -             0x8B       0xffffffff
#----------------------------------------------------------------------------
# 110        ESI        32              -             0x8B       0xffffffff
#----------------------------------------------------------------------------
# 111        EDI        32              -             0x8B       0xffffffff
#----------------------------------------------------------------------------
.code32
.section .text
.globl list_regimm
.type  list_regimm, @function
list_regimm:           
                           
           pushl   %ebp         
           movl	   %esp, %ebp 

           pushl  %eax
           movb   $0xff, %al
           movw   $0xffff,%ax 
           movl   $0xffffffff, %eax    # puts the immediate operand to AX  
           popl   %eax
  
           pushl  %ecx
           movb   $0xff, %cl
           movw   $0xffff, %cx 
           movl   $0xffffffff, %ecx    # puts the immediate operand to CX  
           popl   %ecx
  
           pushl  %edx
           movb   $0xff, %dl
           movw   $0xffff, %dx 
           movl   $0xffffffff, %edx    # puts the immediate operand to CX  
           popl   %edx

           pushl  %ebx
           movb   $0xff, %bl
           movw   $0xffff, %bx
           movl   $0xffffffff, %ebx    # puts the immediate operand to CX  
           popl   %ebx

           pushl  %ebp
           movl   $0xffffffff, %ebp    # puts the immediate operand to CX  
           popl   %ebp

           pushl  %esi
           movl   $0xffffffff, %esi    # puts the immediate operand to CX  
           popl   %esi

           pushl  %edi
           movl   $0xffffffff, %edi    # puts the immediate operand to CX  
           popl   %edi

           xorl %eax, %eax        # This would correspond XOR-operation retval ^= retval in the C code  

           leave                   
           ret				    

