/*****************************************************************
*  parser.h  this header file contains both macros and prototypes functions for 
*  handling integer arguments of the command line 
*  
* Copyright (C) 2009,2015 Andrey Y. Rjavskov(aka rjaan) <rjaan@yandex.ru> 
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software Foundation,
* Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*
*****************************************************************/

#ifndef __PARSER_H
#define __PARSER_H     1

#include <string.h>
#include <config.h>

#ifdef __cplusplus 
extern "C" {
#endif

extern int to_show_help;
extern int to_show_version;
extern int to_run_inums_addition;
extern int to_run_list_regimm;
extern int to_run_bswap_intops;
extern int to_run_xchgw_intops;
extern int to_run_trans_negative;
extern int to_run_trans_positive;
extern int to_run_gnuc_trans_negative;
extern int to_run_gnuc_trans_bitwisenot;
extern int to_run_gnuc_incr_pointer;
extern int to_run_gnuc_decr_pointer;
extern int to_run_gnuc_stmt_expr_max;
extern int to_run_gnuc_unsafe_macros_max;
extern int to_run_gnuc_vla_invalid;
extern int to_run_gnuc_vla_use;
extern int to_run_algthm_single_ll; 

extern int cmdline_opts_parser ( const int argc, char * const *argv );

#define PRINT_VARIABLE(VARIABLE)\
	printf( "%s(): %s = %d\n" , __FUNCTION__, # VARIABLE, VARIABLE )

#define VERSION_BANNER()\
puts ("The " PACKAGE " version " VERSION ".\n"\
      "To report a bug please contact " PACKAGE_BUGREPORT ".");

#define VERSION_SHORTBANNER()\
puts ("The " PACKAGE " version " VERSION ".");


#ifdef __cplusplus 
}
#endif

#endif /*__PARSER_H*/

/*eof*/

